# Create your own website on Skynet

One of the services that Skynet provides is access to a Linux server which also has a webserver.  
Additionally each member gets their own domain:

* ``$USERNAME.users.skynet.ie``
    * This is the core web address
    * <https://silver.users.skynet.ie>
* ``skynet.ie/~$USERNAME``
    * This is backwards compatible to help avoid link rot
    * Redirects to the core address above
    * <https://skynet.ie/~silver>

## Website
There are two ways to create a website on Skynet, Modern and Manual.  
Modern is using Source Control (git), pipelines (CI/CD) and pinch of magic.  
Manual gets you hands on with the process.


### Skynet Account requirement
No matter if you choose Modern or Manual you will need a Skynet account.  
Instructions to do so can be found [on the Create Skynet Account page](./create_account.md).

### Modern
Modern involves using source control to version your site.  
This is then leveraged to automatically deploy to your Skynet account/website.

The core repo for this is [here][deploy_user], it contains all the required info to get it working.  
If this does not suit your needs you can take a look at the [forks which cover different tools][deploy_user_forks].

[deploy_user]: https://forgejo.skynet.ie/Skynet/deploy_user
[deploy_user_forks]: https://forgejo.skynet.ie/Skynet/deploy_user/forks

### Manual
#### Login
Once ye have [logged in](./create_ssh.md) you will be able to create a website on Skynet.


#### Create Files
In your home folder follow these commands to create the folder that can be used to host a website

```bash
mkdir ~/public_html 
chmod 711 ~
chmod -R 755 ~/public_html
cd ~/public_html 
```

In this directory you can create all the relevant files using ``nano`` or ``vim``.  

```bash
# create/edit index.html usign nano
# this opens up a termial based text editor.
nano index.html
```

To exit ``nano`` you need to use ``[ctrl]+[x]`` keys.

#### Transfer files
If you already have the files locally you can copy them over using ``scp``, although it is recommended to do it graphically.

To transfer files graphically you can use these programs:

* [WinSCP][download_winscp]
    * Windows  
* [FileZilla][download_filezilla]
    * Windows
    * Mac
    * Linux

[download_winscp]: https://winscp.net
[download_filezilla]: https://filezilla-project.org/download.php?type=client

Anything put there will be accessible under ``https://$USERNAME.users.skynet.ie``.

## More info
There is a slideshow that might be of use to you: <https://public.skynet.ie/slides/skynet/1_setup.html>